import Gtkinter; _Gtkinter = Gtkinter; del Gtkinter

import _gtktty

_gtktty.pygtk_init()

#some constants ...
CURSOR_INVISIBLE = 0
CURSOR_UNDERLINE = 1
CURSOR_BLOCK     = 2
TTY_STATE_NONE        = 0
TTY_STATE_SCROLL_LOCK = 1
TTY_STATE_NUM_LOCK    = 2
TTY_STATE_SHIFT       = 4
TTY_STATE_CAPS_LOCK   = 8
TTY_STATE_CONTROL     = 16
TTY_STATE_ALT         = 32
TTY_STATE_SUPER       = 64
TTY_STATE_HYPER       = 128

class GtkLed(_Gtkinter.GtkMisc):
	get_type = _gtktty.gtk_led_get_type
	def __init__(self, _obj=None):
		if _obj: self._o = _obj; return
		self._o = _gtktty.gtk_led_new()
	def set_state(self, widget_state, on_off):
		_gtktty.gtk_led_set_state(self._o, widget_state, on_off)
	def switch(self, on_off):
		_gtktty.gtk_led_switch(self._o, on_off)
	def is_on(self):
		return _gtktty.gtk_led_is_on(self._o)
_Gtkinter._name2cls['GtkLed'] = GtkLed

class GtkTerm(_Gtkinter.GtkWidget):
	get_type = _gtktty.gtk_term_get_type
	def __init__(self, _obj=None):
		if _obj: self._o = _obj; return
		raise RuntimeError, "This constructor shouldn't be called"
	def construct(self, width, height, max_width, scrollback):
		_gtktty.gtk_term_construct(self._o, width, height, max_width,
				       scrollback)
	def set_scroll_offset(self, offset):
		_gtktty.gtk_term_set_scroll_offset(self._o, offset)
	def block_refresh(self):
		_gtktty.gtk_term_block_refresh(self._o)
	def force_refresh(self):
		_gtktty.gtk_term_force_refresh(self._o)
	def unblock_refresh(self):
		_gtktty.gtk_term_unblock_refresh(self._o)
	def set_fonts(self, font_normal, font_dim, font_bold, overstrike_bold,
		      font_underline, draw_underline, font_reverse,
		      colors_reversed):
		_gtktty.gtk_term_set_fonts(self._o, font_normal, font_dim,
					   font_bold, overstrike_bold,
					   font_underline, draw_underline,
					   dont_reverse, colors_reversed)
	def set_color(self, index, back, fore, fore_dim, fore_bold):
		_gtktty.gtk_term_set_color(self._o, index, back, fore,
					   fore_dim, fore_bold)
	def select_color(self, fore_index, back_index):
		_gtktty.gtk_term_select_color(self._o, fore_index, back_index)
	def set_dim(self, dim):
		_gtktty.gtk_term_set_dim(self._o, dim)
	def set_bold(self, bold):
		_gtktty.gtk_term_set_bold(self._o, bold)
	def set_underline(self, underline):
		_gtktty.gtk_term_set_underline(self._o, underline)
	def set_reverse(self, reverse):
		_gtktty.gtk_term_set_reverse(self._o, reverse)
	def invert(self):
		_gtktty.gtk_term_invert(self._o)
	def insert_lines(self, n):
		_gtktty.gtk_term_insert_lines(self._o, n)
	def delete_lines(self, n):
		_gtktty.gtk_term_delete_lines(self._o, n)
	def scroll(self, n, downwards):
		_gtktty.gtk_term_scroll(self._o, n, downwards)
	def clear_line(self, before_cursor, after_cursor):
		_gtktty.gtk_term_clear_line(self._o, before_cursor,
					    after_cursor)
	def insert_chars(self, n):
		_gtktty.gtk_term_insert_chars(self._o, n)
	def delete_chars(self, n):
		_gtktty.gtk_term_delete_chars(self._o, n)
	def bell(self):
		_gtktty.gtk_term_bell(self._o)
	def clear(self):
		_gtktty.gtk_term_clear(self._o)
	def set_cursor(self, x, y):
		_gtktty.gtk_term_set_cursor(self._o, x, y)
	def get_cursor(self):
		return _gtktty.gtk_term_get_cursort(self._o)
	def set_cursor_mode(self, mode, blinking):
		_gtktty.gtk_term_set_cursor_mode(self._o, mode, blinking)
	def save_cursor(self):
		_gtktty.gtk_term_save_cursor(self._o)
	def restore_cursor(self):
		_gtktty.gtk_term_restore_cursor(self._o)
	def set_scroll_reg(self, top, bottom):
		_gtktty.gtk_term_set_scroll_reg(self._o, top, bottom)
	def reset(self):
		_gtktty.gtk_term_reset(self._o)
	def get_size(self):
		return _gtktty.gtk_term_get_size(self._o)
	def erase_chars(self, n):
		_gtktty.gtk_term_erase_chars(self._o, n)
	def putc(self, ch, insert):
		_gtktty.gtk_term_putc(self._o, ch, insert)
_Gtkinter._name2cls['GtkTerm'] = GtkTerm

class GtkTty(GtkTerm):
	get_type = _gtktty.gtk_tty_get_type
	def __init__(self, width=80, height=25, scrollback=100, _obj=None):
		if _obj: self._o = _obj; return
		self._o = _gtktty.gtk_tty_new(width, height, scrollback)
	def put_out(self, buf, count=None):
		_gtktty.gtk_tty_put_out(self._o, buf, count or len(buf))
	def put_in(self, buf, count=None):
		_gtktty.gtk_tty_put_in(self._o, buf, count or len(buf))
	def leds_changed(self):
		_gtktty.gtk_tty_leds_changed(self._o)
	def add_update_led(self, led, mask):
		_gtktty.gtk_tty_add_update_led(self._o, led._o, mask)
	def execute(self, prg_name, argv, envp):
		_gtktty.gtk_tty_execute(self._o, prg_name, argv, envp)
_Gtkinter._name2cls['GtkTty'] = GtkTty
